#include <stdio.h>
#include "rle.h"
#define esc		27
#define last	255


int ReadRLE(FILE *thefile,int bytes,void (*XPutChar)(int))
{
	int bytesread=0;
	int a,b,c,t;
	do {
		a = getc(thefile);
		bytesread++;
		if(a!=esc) 
			(XPutChar)(a);
		else {
			b = getc(thefile);
			c = getc(thefile);
			bytesread += 2;
			for(t=0;t<c;t++)
				(XPutChar)(b);
		}
	} while(bytesread<bytes);
}

int WriteRLE(FILE *thefile,int (*XGetChar)(),int *TotB)
{
	int bytesread = 0, byteswritten = 0;
	int a,b,t,num;
	
	num = 1;
	b = (XGetChar)();
	bytesread = 1;
	while ((a=(XGetChar)())!=EOF) {
		bytesread++;
		if (a==b) {
			num++;
			continue;
		} else {
			while(num>255) {
				putc(esc,thefile);
				putc(b,thefile);
				putc(last,thefile);
				num -= 255;
				byteswritten += 3;
			}
			if ((num>2)||(b==esc)) {
				putc(esc,thefile);
				putc(b,thefile);
				putc(num,thefile);
				byteswritten += 3;
			} else {
				for(t=0;t<num;t++) 
					putc(b,thefile);
				byteswritten += num;
			}
			num = 1;
			b = a;
		}
	};
	while(num>255) {
		putc(esc,thefile);
		putc(b,thefile);
		putc(last,thefile);
		num -= 255;
		byteswritten += 3;
	}
	if ((num>2)||(b==esc)) {
		putc(esc,thefile);
		putc(b,thefile);
		putc(num,thefile);
		byteswritten += 3;
	} else{
		for(t=0;t<num;t++) 
			putc(b,thefile);
		byteswritten += num;
	}
	*TotB = bytesread;
	return(byteswritten);
}					
		