#ifndef XLA2_H
#define XLA2_H

#ifndef None				/*Could be defined by X.h*/
#define None            0   /*No compression : store only*/
#endif
#define LZS             1   /*LZS77 compression*/
#define DeflateFast		2  	/*Fast Deflate compression*/
#define DeflateLazy		3  	/*Lazy Deflate compression*/
#define RLE				4	/*RLE compression*/
#define Best            8   /*Not Used*/

#ifndef TRUE
#define TRUE			1
#endif

#ifndef FALSE
#define FALSE           0
#endif

#define boolean int

extern unsigned short ModeUsed;
extern short ratio;

extern void XPrintDir();
extern boolean XCloseArchive();
extern boolean XUpdateArchive(char *filename);
extern boolean XOpenArchive(char *filename);
extern boolean XLAGet(char *fname,void (*XPutChar)(int));
extern boolean XLAPut(char *fname, unsigned int mode,int (*XGetChar)());
extern boolean XEndArchive();
extern boolean XCreateArchive(char *filename);
extern boolean XLAGetFileInfo(char *fname, long *origsize, long *compsize,
				  int *mode);
extern boolean XLAFindFirst(char *pattern, char *match);
extern boolean XLAFindNext(char *match);
extern boolean XLANext(char *match);
extern boolean XLAFirst(char *match);

#endif /*XLA2_H*/